module StompJob
  class Workers

    class << self
      def registered_workers
        @registered_workers ||= []
      end

      def register( worker_klass )
        registered_workers << worker_klass unless registered_workers.include?(worker_klass)
        registered_workers
      end

      # Tells main thread to sleep, and tells all workers to listen for
      # and process any messages they receive.
      def listen!
        registered_workers.each(&:listen!)
        sleep
      end
    end

  end
end
